//+------------------------------------------------------------------+
//|                               based on           RSI_Candles.mq4 |
//|                               Copyright  2012, Gehtsoft USA LLC |
//|                                            http://fxcodebase.com |
//+------------------------------------------------------------------+
#property copyright "RSI_14_Zones"
#property link      "http://fxcodebase.com"

#property indicator_separate_window
#property indicator_buffers 10

#property indicator_maximum 85
#property indicator_minimum 15
#property strict

//---------------------------  the 50 level line   ------------------------- 
#property indicator_levelcolor clrBlue
#property indicator_levelwidth   1;
#property indicator_levelstyle   2;
#property indicator_level1 75
#property indicator_level2 50
#property indicator_level3 25


#define IndName "RSI.14"

extern int Length=14;
extern int MaxBars=1000;
extern color Bullish = clrForestGreen;
extern color Bearish = clrTomato;
extern int CandleWidth=5;

double PrH[], PrL[];



//-------------------- color zone parameters   ---------------------------------------------

extern string    Note1="**** OB/OS Levels ****";
extern int       OBHigh_Upper=85;
extern int       OBHigh_Lower=51;
//extern int       NMid_Upper=8;
//extern int       NMid_Lower=-8;
extern int       OSLow_Upper=49;
extern int       OSLow_Lower=15;

extern string    Note2="**** OB/OS Level Colors ****";
extern color     OBHigh_Color=clrLavenderBlush;
extern color     Normal_Color=clrNONE;
extern color     OSLow_Color=clrHoneydew;

extern int       BarsBack=2000;
extern string    Note1c="BarsAhead=Areas Displayed ahead of current bar";
extern int       BarsAhead=50;

int barsback;

//-------------------- end of color zone parameters   ---------------------------------------------


int Window;

int init()
  {
   IndicatorShortName(IndName);
   IndicatorDigits(Digits);
   SetIndexStyle(0,DRAW_NONE);
   SetIndexBuffer(0,PrH);
   SetIndexStyle(1,DRAW_NONE);
   SetIndexBuffer(1,PrL);

   return(0);
  }

int deinit()
  {
   Window=WindowFind(IndName);
   if (Window!=-1)
   {
    ObjectsDeleteAll(Window, OBJ_TREND);
   }
   return(0);
  }


void DrawCandle(datetime T, double O, double H, double L, double C)
{
 string ObjName=+T;
 double MaxBody=MathMax(O, C);
 double MinBody=MathMin(O, C);
 color CandleColor;
 if (C>=O) CandleColor=Bullish; else CandleColor=Bearish;
 Window=WindowFind(IndName);
 if (Window==-1) return;
 if (ObjectFind(ObjName+"R")!=-1)
 {
  ObjectSet(ObjName+"R", OBJPROP_TIME1, T);
  ObjectSet(ObjName+"R", OBJPROP_TIME2, T);
  ObjectSet(ObjName+"R", OBJPROP_PRICE1, O);
  ObjectSet(ObjName+"R", OBJPROP_PRICE2, C);
 }
 else
 {
  ObjectCreate(ObjName+"R", OBJ_TREND, Window, T, O, T, C);
 } 
 ObjectSet(ObjName+"R", OBJPROP_COLOR, CandleColor);
 ObjectSet(ObjName+"R", OBJPROP_RAY, false);
 ObjectSet(ObjName+"R", OBJPROP_WIDTH, CandleWidth);
 
 if (ObjectFind(ObjName+"H")!=-1)
 {
  ObjectSet(ObjName+"H", OBJPROP_TIME1, T);
  ObjectSet(ObjName+"H", OBJPROP_TIME2, T);
  ObjectSet(ObjName+"H", OBJPROP_PRICE1, MaxBody);
  ObjectSet(ObjName+"H", OBJPROP_PRICE2, H);
 }
 else
 {
  ObjectCreate(ObjName+"H", OBJ_TREND, Window, T, MaxBody, T, H);
 } 
 ObjectSet(ObjName+"H", OBJPROP_COLOR, CandleColor);
 ObjectSet(ObjName+"H", OBJPROP_RAY, false);
 ObjectSet(ObjName+"H", OBJPROP_WIDTH, 1);

 if (ObjectFind(ObjName+"L")!=-1)
 {
  ObjectSet(ObjName+"L", OBJPROP_TIME1, T);
  ObjectSet(ObjName+"L", OBJPROP_TIME2, T);
  ObjectSet(ObjName+"L", OBJPROP_PRICE1, MinBody);
  ObjectSet(ObjName+"L", OBJPROP_PRICE2, L);
 }
 else
 {
  ObjectCreate(ObjName+"L", OBJ_TREND, Window, T, MinBody, T, L);
 } 
 ObjectSet(ObjName+"L", OBJPROP_COLOR, CandleColor);
 ObjectSet(ObjName+"L", OBJPROP_RAY, false);
 ObjectSet(ObjName+"L", OBJPROP_WIDTH, 1);
 return;
}  




int start()
{
 if(Bars<=3) return(0);
 int ExtCountedBars=IndicatorCounted();
 if (ExtCountedBars<0) return(-1);
 int pos;
 int limit=Bars-2;
 
 double O, H, L, C;
 if(ExtCountedBars>2) limit=Bars-ExtCountedBars-1;
 limit=MathMin(limit, MaxBars);
 pos=limit;
 while(pos>=0)
 {
  O=iRSI(NULL, 0, Length, PRICE_OPEN, pos);
  H=iRSI(NULL, 0, Length, PRICE_HIGH, pos);
  L=iRSI(NULL, 0, Length, PRICE_LOW, pos);
  C=iRSI(NULL, 0, Length, PRICE_CLOSE, pos);
  DrawCandle(Time[pos],O,H,L,C);
  PrH[pos]=H;
  PrL[pos]=L;
  pos--;
 } 


 
 
 //+------------------------------------  Color  Zone   ----------------------------------------------------+


     int  window1;

{
  barsback=(Bars-Bars)+BarsBack;
  window1=WindowFind("RSI.14");
         // ***************************** Start Colored Zones ************************************
         // Top
       if(ObjectFind("TopRec1")!=0)
           {
 //              ObjectCreate("TopRec1",OBJ_RECTANGLE,window1,Time[0],OBHigh_Upper,(Time[0]),OBHigh_Lower);
 
               ObjectCreate("TopRec1",OBJ_RECTANGLE,window1,Time[WindowBarsPerChart()],OBHigh_Upper,(Time[0]+((Period()*60)*BarsAhead)),OBHigh_Lower);
            }
         ObjectSet("TopRec1",OBJPROP_COLOR,OBHigh_Color);
         ObjectSet("TopRec1",OBJPROP_TIME1,Time[barsback]);
         ObjectSet("TopRec1",OBJPROP_TIME2,(Time[0]+((Period()*60)*BarsAhead)));
         ObjectSet("TopRec1",OBJPROP_PRICE1,OBHigh_Upper);
         ObjectSet("TopRec1",OBJPROP_PRICE2,OBHigh_Lower);

 /*        // Mid
         if(ObjectFind("MidRec1")!=0)
           {
            if(barsback==0)
              {
               ObjectCreate("MidRec1",OBJ_RECTANGLE,window,Time[WindowBarsPerChart()],NMid_Upper,(Time[0]+((Period()*60)*BarsAhead)),NMid_Lower);
                 }else{
               ObjectCreate("MidRec1",OBJ_RECTANGLE,window,Time[barsback],NMid_Upper,(Time[0]+((Period()*60)*BarsAhead)),NMid_Lower);
              }
           }
         ObjectSet("MidRec1",OBJPROP_COLOR,Normal_Color);
         ObjectSet("MidRec1",OBJPROP_TIME1,Time[barsback]);
         ObjectSet("MidRec1",OBJPROP_TIME2,(Time[0]+((Period()*60)*BarsAhead)));
         ObjectSet("MidRec1",OBJPROP_PRICE1,NMid_Upper);
         ObjectSet("MidRec1",OBJPROP_PRICE2,NMid_Lower);
*/
 
         // Bottom
         if(ObjectFind("BotRec2")!=0)
           {        
               ObjectCreate("BotRec2",OBJ_RECTANGLE,window1,Time[WindowBarsPerChart()],OSLow_Lower,(Time[0]+((Period()*60)*BarsAhead)),OSLow_Upper);
           }
         ObjectSet("BotRec2",OBJPROP_COLOR,OSLow_Color);
         ObjectSet("BotRec2",OBJPROP_TIME1,Time[barsback]);
         ObjectSet("BotRec2",OBJPROP_TIME2,(Time[0]+((Period()*60)*BarsAhead)));
         ObjectSet("BotRec2",OBJPROP_PRICE1,OSLow_Lower);
         ObjectSet("BotRec2",OBJPROP_PRICE2,OSLow_Upper);
 }

         // ****************************** End Colored Zones *************************************


 return(0);
}
